<?php

define('MODEL_SIMULATION_LOCAL', true); // set to true for proudction mode

class FGPAuthorModel extends eSourceGhostWriterPluginModel{
    
    public $publisher_id;
    
    public $author_id;
    
    public function setPublisherId($publisher_id){
        
        $this->publisher_id = $publisher_id;
        
    }
    
    public function setAuthorId($author_id){
        
        $this->author_id = $author_id;
        
    }
    
    
    public function registerNewAuthor($post_array){

        $api_url = $this->api_url . 'users/registerauthor/' . $this->api_key;
        
        $request = new WP_Http;

        $res = $request->request( $api_url , array( 'method' => 'POST', 'body' => $post_array ));

        return json_decode($res['body']);

    }
    
    
    public function loadMyArticlesViaApi(){
        
        if(!isset($this->author_id) && empty($this->author_id)){
            return false;
        }
        
        $api_url = $this->api_url . 'articles/getapiarticles/' . $this->api_key . '/' . $this->author_id;
        
        $request = new WP_Http;

        $res = $request->request( $api_url , array( 'method' => 'GET'));

        return json_decode($res['body']);
        
       
    }


    public function saveEditArticle($post_array, $article_id){

        $api_url = $this->api_url . 'articles/updatearticle/' . $this->api_key . '/' . $article_id;

        $request = new WP_Http;

        $res = $request->request( $api_url , array( 'method' => 'POST', 'body' => $post_array ));

        return json_decode($res['body']);

    }


    public function deleteArticle($article_id){

        $api_url = $this->api_url . 'articles/deletearticle/' . $this->api_key . '/' . $article_id;

        $request = new WP_Http;

        $res = $request->request( $api_url , array( 'method' => 'GET'));

        return json_decode($res['body']);

    }


    public function getArticlesForApproval(){

        $api_url = $this->api_url . 'articles/getallforapproval/' . $this->api_key . '/' . $this->author_id;

        $request = new WP_Http;

        $res = $request->request( $api_url , array( 'method' => 'GET'));

        return json_decode($res['body']);
   
    }

    public function getArticleForApproval($approval_id){

        $api_url = $this->api_url . 'articles/getforapproval/' . $this->api_key . '/' . $approval_id;

        $request = new WP_Http;

        $res = $request->request( $api_url , array( 'method' => 'GET'));

        return json_decode($res['body']);

    }

    public function processArticleApproval($approval_id, $status = 1){
        
        $api_url = $this->api_url . 'articles/processapproval/' . $this->api_key . '/' . $approval_id . '/' . $status;

        $request = new WP_Http;

        $res = $request->request( $api_url , array( 'method' => 'GET'));

        return json_decode($res['body']);
        
    }

    public function getContentRequestById($arc_id){

        $api_url = $this->api_url . 'contentrequest/getbyid/' . $this->api_key . '/' . $arc_id;

        $request = new WP_Http;

        $res = $request->request( $api_url , array( 'method' => 'GET'));

        return json_decode($res['body']);

    }

    public function processContentRequest($post_array, $arc_id){

        $api_url = $this->api_url . 'contentrequest/process/' . $this->api_key . '/' . $arc_id . '/' . $this->author_id;
        
        $request = new WP_Http;

        $res = $request->request( $api_url , array( 'method' => 'POST', 'body' => $post_array ));

        return json_decode($res['body']);

    }

    
}