<?php

define('MODEL_SIMULATION_LOCAL', false); // set to true for proudction mode

class eSourceGhostWriterPluginModel{
    
    public $api_key;
    public $api_url;
    public $api_action_url;
    
    public function __construct(){
        
        if(MODEL_SIMULATION_LOCAL){
            $this->api_url = 'http://freeguestpost.com/app/api/';
        }else{
            $this->api_url = 'http://freeguestpost.com/app/api/';
        }
     
    }
    
    public function setApiKey($api_key){
        
        $this->api_key = $api_key;
        
    }

    
    /*public function parse($url){
        
        $url = $this->api_url . $url . $this->api_key;

        $response = wp_remote_get( $url );
        
        if( is_wp_error( $response ) ) {
            
            return $response->get_error_message();
            
        } else {

           $data = json_decode($response['body']);

           return $data->data;
        }

    }   */
    
    public function parse($url){
                   
        $api_url = $this->api_url . $url . $this->api_key;
     
        $post_array['free_writer_plugin_options'] = get_option('free_writer_plugin_options');  
        
        $post_array['website'] = $_SERVER['SERVER_NAME']; 
        
        $request = new WP_Http;

        $res = $request->request( $api_url , array( 'method' => 'POST', 'body' => $post_array ));        
        
        if (count($res->errors) == 0) {
          $data = json_decode($res['body']);  
        }      

        return $data->data;
        
    }
    

    public function registerNewPublisher($post_array){
        
        $api_url = $this->api_url . 'publisher/register';
     
        $request = new WP_Http;

        $post_array['site_url'] = $_SERVER['SERVER_NAME'];
        
        $res = $request->request( $api_url , array( 'method' => 'POST', 'body' => $post_array ));        
        
        return json_decode($res['body']);
        
    }
    
    public function validateApiKey($api_key){
        
        $api_url = $this->api_url . 'publisher/validateapikey/' . $api_key;
        
        $post_array['site_url'] = $_SERVER['SERVER_NAME']; 
        
        $request = new WP_Http;

        $res = $request->request( $api_url , array( 'method' => 'POST', 'body' => $post_array ));  
        
        return json_decode($res['body']);
        
    }
    
    
    public function getArticle($article_id){
        
        $api_url = $this->api_url . 'articles/getarticlebyid/' . $this->api_key . '/' . $article_id;

//        echo $api_url;
        
        $request = new WP_Http;

        $res = $request->request( $api_url , array( 'method' => 'GET'));
        
        return json_decode($res['body']);
        
    }
    
    public function getCategories(){
        
        $cats = get_categories(array('hide_empty' => 0, 'orderby' => 'id'));
        
        $ret_val = array();
        
        foreach($cats as $key => $obj_category){
            
            $ret_val[] = array('term_id' => $obj_category->term_id, 'name'=> $obj_category->name, 'slug' => $obj_category->slug);
            
        }
        
        return $ret_val;
        
    }
    
    public function getApiCategories(){
        
        $api_url = $this->api_url . 'categories/getall/' . $this->api_key;
        
        $request = new WP_Http;

        $res = $request->request( $api_url , array( 'method' => 'GET'));
     
        $api_categories = array();
        
        if (count($res->errors) == 0) {
        
          $res = json_decode($res['body']);    
              
          foreach($res->data->categories as $key => $obj_category){
              
              $api_categories[$obj_category->id] = $obj_category->name;
          }
        }
        
        return $api_categories;       
        
    }
    
    public function searchArticle($post_array){
        
        $api_post = array();
  
        switch($post_array['search_by']){
            
            case 'word_lenght_or_most_published_authors':
                
                $api_post = array('search_by'=> $post_array['search_by'], 
                                     'search_by_label' => 'Word Lenght or Most Published Authors',
                                     'keyword' => $post_array['word_lenght_or_most_published_authors'],
                                     'title'  => $post_array['word_lenght_or_most_published_authors']);
               
                break;
            
            case 'title':
          
                $api_post = array('search_by'=>  $post_array['search_by'], 
                                    'search_by_label' => 'Title',
                                     'keyword' => $post_array['title'],                    
                                     'title'  => $post_array['title']);
                                
                break;
            
            case 'category':
          
                $api_post = array('search_by'=>  $post_array['search_by'], 
                                     'search_by_label' => 'Category',
                                     'keyword' => $post_array['category'],                    
                                     'category'  => $post_array['category']);
                                
                break;
            
            default:
                
                $api_post = array('search_by'=>  $post_array['search_by'], 
                                     'search_by_label' => 'Tags',
                                     'keyword' => $post_array['tags'],                                        
                                     'tags'  => $post_array['tags']);                
                
                break;
        }
        
        $api_url = $this->api_url . 'articles/search/' . $this->api_key;
     
        $request = new WP_Http;

        $res = $request->request( $api_url , array( 'method' => 'POST', 'body' => $api_post ));    
        
        return json_decode($res['body']);
        
    }

    public function getPublishedArticles(){

        $api_url = $this->api_url . 'publisher/getpublishedarticles/' . $this->api_key;
        
        $post_array['site_url'] = $_SERVER['SERVER_NAME'];
        
        $request = new WP_Http;

        $res = $request->request( $api_url , array( 'method' => 'POST', 'body' => $post_array ));

        $res = json_decode($res['body']);

        return $res->data->published_articles;
       
    }

    public function setArticleAsPublished($article_id, $post_id){

        $api_url = $this->api_url . 'publisher/setarticleaspublish/' . $this->api_key . '/' . $article_id . '/' . $post_id ;
        
        $post_array['site_url'] = $_SERVER['SERVER_NAME'];
                
        $request = new WP_Http;

        $request->request( $api_url , array( 'method' => 'POST', 'body' => $post_array ) );

    }
    
    public function getContentRequests(){
        
        $api_url = $this->api_url . 'contentrequest/getall/' . $this->api_key . '/';
        
        $post_array['website'] = $_SERVER['SERVER_NAME'];

        $request = new WP_Http;

        $result = $request->request( $api_url , array( 'method' => 'POST', 'body' => $post_array ));  
        
        if (count($result->errors) == 0) {
          $res = json_decode($result['body']);
        }
        
        return $res->data->content_requests;
        
    }
    
    public function addNewContentRequest($post_array){
        
        $api_url = $this->api_url . 'contentrequest/addnew/' . $this->api_key;
        
        $post_array['website'] = $_SERVER['SERVER_NAME'];
     
        $request = new WP_Http;

        $res = $request->request( $api_url , array( 'method' => 'POST', 'body' => $post_array ));
        
        return json_decode($res['body']);
        
    }
    
    public function sendApprovalRequest($post_array){
        
        $api_url = $this->api_url . 'articles/requestapproval/' . $this->api_key;
        
        $post_array['website'] = $_SERVER['SERVER_NAME']; 
     
        $request = new WP_Http;

        $res = $request->request( $api_url , array( 'method' => 'POST', 'body' => $post_array ));
       
        return json_decode($res['body']);
        
    }
    
    
    public function getRequestedChangesById($arc_id){
        
        $api_url = $this->api_url . 'requestedcontent/get/' . $this->api_key . '/' . $arc_id;

        $request = new WP_Http;

        $res = $request->request( $api_url , array( 'method' => 'POST', 'body' => $post_array ));
       
        return json_decode($res['body']);      
        
    }
    
    public function processRequestChanges($post_array){

        $api_url = $this->api_url . 'requestedcontent/processnew/' . $this->api_key;
        
        $request = new WP_Http;

        $res = $request->request( $api_url , array( 'method' => 'POST', 'body' => $post_array ));
       
        return json_decode($res['body']);          
        
    }
    
    public function getContentRequestById($arc_id){

        $api_url = $this->api_url . 'contentrequest/getbyid/' . $this->api_key . '/' . $arc_id;

        $request = new WP_Http;

        $res = $request->request( $api_url , array( 'method' => 'GET'));

        return json_decode($res['body']);

    }
    
     public function processContentRequest($post_array, $arc_id){

        $api_url = $this->api_url . 'contentrequest/savecontentrequest/' . $this->api_key . '/' . $arc_id;
        
        $request = new WP_Http;

        $res = $request->request( $api_url , array( 'method' => 'POST', 'body' => $post_array ));

        return json_decode($res['body']);

    }
    
     public function deleteContentRequest($post_array){
     
        $api_url = $this->api_url . 'contentrequest/deletecontentrequest/' . $this->api_key ;
        
        $request = new WP_Http;

        $res = $request->request( $api_url , array( 'method' => 'POST', 'body' => $post_array ));

        return json_decode($res['body']);

    }
    
    public function setPublishedArticleAsDeleted($post_id){

        $api_url = $this->api_url . 'publisher/setpublishedarticleasdelete/' . $this->api_key . '/' . $post_id ;
       
        $post_array['site_url'] = $_SERVER['SERVER_NAME']; 
        
        $request = new WP_Http;

        $request->request( $api_url , array( 'method' => 'POST',  'body' => $post_array));
        
        
    }
    
    public function setArticleAsDeclined($post_array){

        $api_url = $this->api_url . 'articles/setarticleasdecline/' . $this->api_key;
       
        $post_array['site_url'] = $_SERVER['SERVER_NAME'];  
        
        $request = new WP_Http;

        $res = $request->request( $api_url , array( 'method' => 'POST', 'body' => $post_array ));
        
        return json_decode($res['body']);       
        
    }
    
    public function getPublisherEmailNotification(){

        $api_url = $this->api_url . 'publisher/getpublisheremailnotification/' . $this->api_key;
       
        $post_array['site_url'] = $_SERVER['SERVER_NAME'];  
        
        $request = new WP_Http;

        $res = $request->request( $api_url , array( 'method' => 'POST', 'body' => $post_array ));
        
        $res =  json_decode($res['body']);  
      
        return $res->data->publisher_email_notification;     
        
    }
    
    public function savePublisherSettings($settings) {
        $api_url = $this->api_url . 'publisher/savepublishersettings/' . $this->api_key;
       
        $post_array['site_url'] = $_SERVER['SERVER_NAME']; 
        
        $post_array['settings'] = $settings; 
        
        $request = new WP_Http;

        $res = $request->request( $api_url , array( 'method' => 'POST', 'body' => $post_array ));
        
        return json_decode($res['body']);        
    
    }
    
    public function savePublisherEmailNotification($enable_email_notification) {
        $api_url = $this->api_url . 'publisher/savepublisheremailnotification/' . $this->api_key;
       
        $post_array['site_url'] = $_SERVER['SERVER_NAME']; 
        
        $post_array['enable_email_notification'] = $enable_email_notification; 
        
        $request = new WP_Http;

        $res = $request->request( $api_url , array( 'method' => 'POST', 'body' => $post_array ));
        
        return json_decode($res['body']);        
    
    }
    
    public function sendFeedback($post_array) {
      
        $api_url = $this->api_url . 'publisher/feedback/' . $this->api_key;
       
        $post_array['site_url'] = $_SERVER['SERVER_NAME']; 
        
        $request = new WP_Http;

        $res = $request->request( $api_url , array( 'method' => 'POST', 'body' => $post_array ));
        
        return json_decode($res['body']);        
    
    }

}